/******************************************************************************/
/*Files to Include                                                            */
/******************************************************************************/

#include <xc.h>         /* XC8 General Include File */

#include <stdint.h>        /* For uint8_t definition */
#include <stdbool.h>       /* For true/false definition */

#include "system.h"


//void ConfigureOscillator(void)
//{
//    OSCCONbits.IRCF = 0b1110; // =8 MHz or 32 MHz HF (depends on PLL 4x setting)
//
//    /* Typical actions in this function are to tweak the oscillator tuning
//    register, select new clock sources, and to wait until new clock sources
//    are stable before resuming execution of the main project. */
//}

//void Init_timer0(void)
//{
//    TMR0CS = 0;       // User internal instruction cycle clock (FOSC/4)
//    PSA = 0;        // 0  = Prescaler is assigned to the Timer0 module
//
//}

//void Init_timer1(void)
//{
//    T1CONbits.TMR1CS	= 0b00; // 11  = Timer1 clock source is Capacitive Sensing Oscillator (CAPOSC)
//                                // 01  = Timer1 clock source is system clock (FOSC)
//                                // 00  = Timer1 clock source is instruction clock (FOSC/4)
//    T1CONbits.T1CKPS 	= 0b11; // 11  = 1:8 Prescale value
//    T1CONbits.T1OSCEN 	= 0;    // 1  = Dedicated Timer1 oscillator circuit enabled
//    T1CONbits.nT1SYNC  	= 1;    // 1  = Do not synchronize external clock input
//    T1CONbits.TMR1ON 	= 1;    // 1  = Enables Timer1
//
//    // timer init
//    TMR1H = TIMER1_H;
//    TMR1L = TIMER1_L;
//
//}

//void Init_timer2(void)
//{
//    PR2 = TIMER2_CPS;
//    // PR2 if 0xFF on reset
//
//    T2CONbits.T2OUTPS = 0b1111; // 1111  = 1:16 Postscaler
//    T2CONbits.T2CKPS = 0b11;      // 11  = Prescaler is 64, 0b10 = 16, 0b01 = 4
//    T2CONbits.TMR2ON = 1;
//
//    TMR2 = 0;
//
//    TMR2IF = false;        // clear interrupt
//    TMR1IE = true;    // enable Timer1 interrupt
//}

/* 10 ms system timer */
void Init_timer4(void)
{    
    PR4 = TIMER4_SYS;
    // PR2 if 0xFF on reset

//    T4CONbits.T4OUTPS = 0b0111; // 0111  = 1:8 Postscaler
//    T4CONbits.TMR4ON = 1;
//    T4CONbits.T4CKPS = 0b10;      // 11  = Prescaler is 64, 0b10 = 16, 0b01 = 4
//    T4CON = 0b00111111;  // T4OUTPS = 0b0111, TMR4ON = 1, T4CKPS = 0b11 @ 32MHz
//    T4CON = 0b00011111;  // T4OUTPS = 0b0011, TMR4ON = 1, T4CKPS = 0b11 @ 16MHz
    Timer4Config_LS();
    
    TMR4 = 0;
    
    TMR4IF = false;        // clear interrupt
    TMR4IE = true;  // enable Timer4 interrupt
}

/* time base for RF TX */
void Init_timer6(void)
{
//    PR6 = TIMER6_CPS;
    // PR6 if 0xFF on reset

//    T6CONbits.T6OUTPS = 0b1111; // 1111  = 1:16 Postscaler
//    T6CONbits.TMR6ON = 1;
//    T6CONbits.T6CKPS = 0b10;      // 11  = Prescaler is 64, 0b10 = 16, 0b01 = 4
    
//    TMR6 = 0;
    T6CON = 0b01111101; // T6OUTPS = 0b1111, TMR6ON = 1, T6CKPS = 0b01
    
    TMR6IF = false;        // clear interrupt
//    TMR6IE = true;  // enable Timer6 interrupt
}

//void set_cpu_seed_high(void)   // switch from slow to fast CPU speed
//{
//    Timer4Config_HS();
//    Timer6Config_HS();
//    OSCCONbits.IRCF = 0b1111; // CPU @16 MHz
//}

//void set_cpu_seed_low(void)   // switch from fast to slow CPU speed. Use for init as well
//{
//    OSCCONbits.IRCF = 0b1101; // CPU @4 MHz
////    Init_timer4();
//    Timer4Config_LS();
////    Timer6Config_LS();
//    T6CONbits.TMR6ON = false;   // turn off timer 6, RF TX module not used with slow CPU speed
//}
