/******************************************************************************/
/* Files to Include                                                           */
/******************************************************************************/
#if defined(__XC)
    #include <xc.h>         /* XC8 General Include File */
#elif defined(HI_TECH_C)
    #include <htc.h>        /* HiTech General Include File */
#endif

#include <stdint.h>         /* For uint8_t definition */
#include <stdbool.h>        /* For true/false definition */

#include "user.h"
#include "system.h"

/******************************************************************************/
/* User Functions                                                             */
/******************************************************************************/

/* <Initialize variables in user.h and insert code for user algorithms.> */

void InitApp(void)
{
    /* Setup analog functionality and port direction */

    /* Setting the GPIO of PORTB */
    ANSELB = 0b00110010;    // RB1,4,5 analog input

     /* Setting the GPIO of PORTA */
    ANSELA = 0x00;
    LATA = 0x00;
    LATB = 0x00;
    
    /* Define IO mode, as input (tri-stated) or output */
    TRISA = 0b00100000;  // (RA5=MCLR is input only - RA5 input pin disabled, when MCLR pin enabled)
    TRISB = 0b00111111; // RB6, 7 output

//    OPTION_REG = 0b11011111;
    
    /* Initialize peripherals */
    
    /* configure ADC */
//    ADON = 1;   // ADC einschalten
//    ADFM = 1;   // ADC Daten rechtsbndig
//    ADCON1bits.ADCS = 0b001; // FOSC/8
    ADCON1 = 0b10010000;    //  ADFM = 1, ADCS = 0b001 (FOSC/8), ADNREF = 0, ADPREF = 00

    /* Enable interrupts */
    // seperate function
}

void Enable_interrupts(void)
{
    IOCBF = 0x00;   // clear all Interrupt-on-Change flags bit
    INTCONbits.IOCIE = 1;   // Interrupt-on-Change Enable bit
    IOCBP0 = 1;     // 1  = Interrupt-on-change  enabled  on  the  pin  for  a  positive  going  edge

    PEIE = true;    // Peripheral Interrupt Enable bit (also needed for Timer1 interrupt)
    GIE = true;     // global interrupt
}

/* run ADC and wait for completion */
void adc_read(void)
{
    __delay_us(2);  // aquisition time
    
    ADCON0bits.GO = 1;  // start conversion
    while (ADCON0bits.GO_nDONE) // wait until done
        ;
    
    ADON = false;   // ADC ausschalten
}
