/******************************************************************************/
/* User Level #define Macros                                                  */
/******************************************************************************/

/* Remove Month from the RTC/Calendar and a few other things to manage the memory size with the free XC8 compiler */
#define REDUCED_CODE_SIZE

// TX code: 0 = 0b01000100, 1 = 0b01110111, F = 0b01000111
#define HS2260A_CodeLogical_Zero    0b01000100
#define HS2260A_CodeLogical_One     0b01110111
#define HS2260A_CodeLogical_F       0b01000111
#define RFTX_NUMBER_OF_SAMPLES    8     // send n samples of entire frame in a series
#define RFTX_NUMBER_OF_RECEIVERS  3     // how many receivers are available? (codes need to be defined!) - max. 4!

#define SCHALTZEITEN_PRO_TAG_MAX    12 //8
#define POWER_OFF_DELAY 30  // idle time (seconds) to turn DC step-up module off
#define LOW_BATTERY_LEVEL   640  // low batt warning level

// menu
/* menu and buttons */
#define NO_BUTTON 0xFF
#define MENU_IDLE_TIMER 10  // idle time *1s

#define BUTTON_UP   0
#define BUTTON_DOWN 1
#define BUTTON_OK   2
#define BUTTON_A    3
#define BUTTON_B    4
#define BUTTON_C    5
//#define BUTTON_TOTAL_NUM   6
#define BUTTON_DEBOUNCE_COUNT  4

// Timeouts fr Empfang
#define KEIN_DCF_MINUTEN        240     // Nach 4 Stunden geht die Uhr auf Strung

/******************************************************************************/
/* User Function Prototypes                                                   */
/******************************************************************************/

void InitApp(void);         /* I/O and Peripheral Initialization */
void read_eeprom_values(void);
void Enable_interrupts(void);
void DekodiereZeit(void);
char ParitaetsCheck(unsigned char wert);
void RFTX_Send(unsigned char channel, unsigned char command);
void adc_read(void);
//void MesseTemperaturIntern(void);
void ReadButtons(void);
//void DCDC_Power_On_Off(void);
void GetBatteryStatus(void);

unsigned char ZufallsBit(void);

void menu_curup(void);
void menu_curdown(void);
void menu_entersub(void);
void menu_back(void);

void menu_exit_eeprom_save_value(void);

//void menu_enter_change_ldr_level(void);
//void menu_enter_change_ldr_relais_one(void);
//void menu_enter_change_ldr_relais_two(void);
//void menu_enter_change_in_relais_one(void);
//void menu_enter_change_in_relais_two(void);
void menu_exit_change_relay(void);
//void menu_val_ldr_up(void);
//void menu_val_ldr_down(void);
//void menu_enter_change_ldr_samples(void);
//void menu_enter_change_ldr(unsigned char value);
void menu_relais_weekday_toggle(void);

void menu_timer_addr_up(void);
void menu_timer_addr_down(void);
void menu_enter_change_timer_weekday(void);
void menu_enter_select_timer_memory(void);
void menu_exit_select_timer_memory(void);
void menu_enter_timer(void);
void menu_read_ee_timer(void);

void menu_timer_change_time_up(void);
void menu_timer_change_time_down(void);
//void menu_enter_timer_change_time(void);
void menu_enter_timer_change_time_or_relay(void);
void menu_exit_timer_change_time(void);
//void menu_enter_timer_change_relay(void);
void menu_timer_change_relay_one(void);
void menu_timer_change_relay_two(void);
void menu_timer_change_relay_three(void);
void menu_timer_change_relay_four(void);
void menu_exit_timer_change_relay(void);
void menu_exit_timer_clearall(void);
void menu_enter_change_TimerRandomMax(void);
void menu_enter_TimerRandomMax_up(void);
void menu_enter_TimerRandomMax_down(void);
void menu_timer_change_random_enabled(void);

void dummyfunc(void);
unsigned char menu_get_next_item(void);
unsigned char menu_get_previous_item(void);

void LCD_display(void);

void print_relais_status(void);
void print_relais_statusTwo(void);
void print_time_status(void);
void print_time(unsigned char Stunde, unsigned char Minute);
//void print_ldr_sensor_value(void);
void print_changed_value(void);
void print_timer_weekday(void);
void print_timer_memory_address(void);
void print_timer_new_time(void);
void print_timer_new_time_hhmm(void);
void print_timer_status_relay(unsigned char RelayToDisplay);
void print_timer_relay_status_one(void);
void print_timer_relay_status_two(void);
void print_timer_relay_status_three(void);
void print_timer_relay_status_four(void);

void print_battery_status(void);

//void print_timer_TimerRandomMax(void);
void print_timer_random_enabled(void);

void Print_ON_OFF_Status(char PortStatus);
void Print_SelectWeekday(void);

void print_debug_status(void);
